#include <string.h>

#include "log.h"
#include "d88.h"
#include "common.h"
#include "osd.h"


////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
cD88::cD88( void ) : Protected(false)
{
	PRINTD( D88_LOG, "[D88][cD88]\n" )
	
	INITARRAY( FileName, '\0' );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
cD88::~cD88( void )
{
	if( d88.fp ) fclose( d88.fp );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
bool cD88::Init( char *fname )
{
	PRINTD1( D88_LOG, "[D88][Init] %s\n", fname )
	
	strncpy( FileName, fname, PATH_MAX );
	
	// ǎpȂveNgԂŊJ
	if( OSD_FileReadOnly( FileName ) ){
		d88.fp = FOPENEN( FileName, "rb" );
		Protected = true;	// veNgV[
	}else{
		d88.fp = FOPENEN( FileName, "rb+" );
		Protected = false;	// veNgV[Ȃ
	}
	
	if( !d88.fp ){
		*FileName = 0;
		Protected = false;
		return false;
	}
	
	ReadHeader88();	// D88 wb_Ǎ
	
	return true;
}


////////////////////////////////////////////////////////////////
// D88 wb_Ǎ
////////////////////////////////////////////////////////////////
void cD88::ReadHeader88( void )
{
	PRINTD( D88_LOG, "[D88][ReadHeader88]\n" )
	
	if( d88.fp ){
		// DISK
		fread( d88.name, sizeof(BYTE), 17, d88.fp );
		d88.name[16] = '\0';
		
		// U[uǂ
		fread( d88.reserve, sizeof(BYTE), 9, d88.fp );
		
		// CgveNg
		d88.protect = fgetc( d88.fp );
		if( d88.protect ) Protected = true;
		else if( Protected ) d88.protect = 0x10;
		
		// DISK̎
		d88.type = fgetc( d88.fp );
		
		// DISK̃TCY
		d88.size = FGETDWORD( d88.fp );
		
		// gbÑItZbge[u
		for( int i=0; i<164; i++ )
			d88.table[i] = FGETDWORD( d88.fp );
		
		PRINTD1( D88_LOG, " FileName : %s\n", d88.name )
		PRINTD1( D88_LOG, " Protect  : %s\n", d88.protect ? "ON" : "OFF" )
		PRINTD1( D88_LOG, " Format   : %d\n", d88.type )
		PRINTD1( D88_LOG, " Size     : %d\n", (int)d88.size )
	}
}


////////////////////////////////////////////////////////////////
// D88 ZN^Ǎ
////////////////////////////////////////////////////////////////
void cD88::ReadSector88( void )
{
//	PRINTD( D88_LOG, "[D88][ReadSector88]\n" );
	
	if( d88.fp ){
		d88.secinfo.c = fgetc( d88.fp );			// ID  C (V_No Жʂ̏ꍇ=gbNNo)
		d88.secinfo.h = fgetc( d88.fp );			// ID  H (wb_AhX Жʂ̏ꍇ=0)
		d88.secinfo.r = fgetc( d88.fp );			// ID  R (gbÑZN^No)
		d88.secinfo.n = fgetc( d88.fp );			// ID  N (ZN^TCY 0:256 1:256 2:512 3:1024)
		d88.secinfo.sec_nr  = FGETWORD( d88.fp );	// ̃gbNɑ݂ZN^̐
		d88.secinfo.density = fgetc( d88.fp );		// L^x     0x00:{x   0x40:Px
		d88.secinfo.deleted = fgetc( d88.fp );		// DELETED MARK 0x00:m[} 0x10:DELETED
		d88.secinfo.status  = fgetc( d88.fp );		// Xe[^X
		fread( d88.secinfo.reserve, sizeof(BYTE), 5, d88.fp );	// U[uǂ
		d88.secinfo.size   = FGETWORD( d88.fp );	// ̃ZN^̃f[^TCY
		d88.secinfo.data   = ftell( d88.fp );		// f[^ւ̃ItZbg
		d88.secinfo.offset = 0;						// ɓǍރf[^̃ZN^擪̃ItZbg
		
//		PRINTD1( D88_LOG, " C      : %d\n", d88.secinfo.c )
//		PRINTD1( D88_LOG, " H      : %d\n", d88.secinfo.h )
//		PRINTD1( D88_LOG, " R      : %d\n", d88.secinfo.r )
//		PRINTD1( D88_LOG, " N      : %d\n", d88.secinfo.n )
//		PRINTD1( D88_LOG, " SectNum: %d\n", d88.secinfo.sec_nr )
//		PRINTD1( D88_LOG, " Density: %s\n", d88.secinfo.density&0x40 ? "D" : "DD" )
//		PRINTD1( D88_LOG, " Del    : %s\n", d88.secinfo.deleted&0x10 ? "DELETED" : "NORMAL" )
//		PRINTD1( D88_LOG, " Stat   : %02X\n", d88.secinfo.status )
//		PRINTD1( D88_LOG, " Size   : %d\n", d88.secinfo.size )
//		PRINTD1( D88_LOG, " Offset : %d\n", (int)d88.secinfo.data )
	}
}


////////////////////////////////////////////////////////////////
// 1byte Ǎ
////////////////////////////////////////////////////////////////
BYTE cD88::Getc88( void )
{
	PRINTD( D88_LOG, "[D88][Getc88] -> " )
	
	if( d88.fp ){
		BYTE dat = fgetc( d88.fp );
		d88.secinfo.offset++;
		
		PRINTD1( D88_LOG, "%02X\n", dat );
		
		// ZN^̏IɓB玟̃ZN^V[N
		// (ق?߂ēgbNɌ肵Ƃق?)
		if( d88.secinfo.offset >= d88.secinfo.size ) ReadSector88();
		
		return dat;
	}
	PRINTD( D88_LOG, "false(0xff)\n" );
	
	return 0xff;
}


////////////////////////////////////////////////////////////////
// 1byte 
////////////////////////////////////////////////////////////////
bool cD88::Putc88( BYTE dat )
{
	PRINTD5( D88_LOG, "[D88][Putc88] -> %02X(%02d:%02d:%02d:%02d)", dat, d88.secinfo.c, d88.secinfo.h, d88.secinfo.r, d88.secinfo.n );
	
	if( d88.fp && !d88.protect ){
		fseek( d88.fp, 0, SEEK_CUR );	// ܂ۂ
		fputc( dat, d88.fp );
		fseek( d88.fp, 0, SEEK_CUR );	// 
		d88.secinfo.offset++;
		
		// ZN^̏IɓB玟̃ZN^V[N
		// (ق?߂ēgbNɌ肵Ƃق?)
		if( d88.secinfo.offset >= d88.secinfo.size ) ReadSector88();
		
		PRINTD( D88_LOG, " ->OK\n" );
		
		return true;
	}
	PRINTD( D88_LOG, " ->NG\n" );
	
	return false;
}


////////////////////////////////////////////////////////////////
// V[N
////////////////////////////////////////////////////////////////
bool cD88::Seek88( int trackno, int sectno )
{
	PRINTD2( D88_LOG, "[D88][Seek88] Track : %d Sector : %d", trackno, sectno );
	
	if( d88.fp ){
		// gbNȂG[
		if( !d88.table[trackno] ) return false;
		PRINTD1( D88_LOG, " -> Track:%d\n", trackno );
		
		// gbN̐擪V[N
		fseek( d88.fp, d88.table[trackno], SEEK_SET );
		
		// ŏ̃ZN^Ǎ
		ReadSector88();
		if( d88.secinfo.sec_nr < sectno ) return false;	// ZN^ԍ͗L?
		PRINTD1( D88_LOG, " -> Sector:%d", sectno );
		
		// ړĨZN^܂ŋǂ
		int TryCnt = 2;	// gC񐔃JE^
		while( d88.secinfo.r != sectno ){
			// gbN2ČȂ΃G[
			if( !TryCnt ) return false;
			fseek( d88.fp, (long)d88.secinfo.size, SEEK_CUR );
			ReadSector88();	// ̃ZN^Ǎ
			if( d88.secinfo.r == d88.secinfo.sec_nr ) TryCnt--;
		}
		PRINTD( D88_LOG, " -> OK\n" );
		
		return true;
	}
	PRINTD( D88_LOG, " -> false\n" );
	
	return false;
}


////////////////////////////////////////////////////////////////
// ݂CHRN擾
////////////////////////////////////////////////////////////////
DWORD cD88::GetCHRN( void )
{
	PRINTD( D88_LOG, "[D88][GetCHRN]\n" );
	
	return d88.secinfo.c<<24 || d88.secinfo.h<<16 || d88.secinfo.r<<8 || d88.secinfo.n;
}


////////////////////////////////////////////////////////////////
// t@C擾
////////////////////////////////////////////////////////////////
char *cD88::GetFileName( void )
{
	return FileName;
}


////////////////////////////////////////////////////////////////
// DISKC[W擾
////////////////////////////////////////////////////////////////
char *cD88::GetDiskImgName( void )
{
	return (char *)d88.name;
}


////////////////////////////////////////////////////////////////
// veNgV[Ԏ擾
////////////////////////////////////////////////////////////////
bool cD88::IsProtect( void )
{
	return Protected;
}
